From 0c669ea3d10d707f5210449c9c98d57b46c501ef Mon Sep 17 00:00:00 2001
From: David Tolnay <dtolnay@gmail.com>
Date: Dec 31 2020 04:02:35 +0000
Subject: [PATCH 1907/2232] Replace ref cast to RustName with just using Ident


---

diff --git a/syntax/mod.rs b/syntax/mod.rs
index 4dd18ea..64ff8e7 100644
--- a/syntax/mod.rs
+++ b/syntax/mod.rs
@@ -255,7 +255,6 @@ pub struct Pair {
 // Wrapper for a type which needs to be resolved before it can be printed in
 // C++.
 #[derive(Clone, PartialEq, Eq, PartialOrd, Ord, Hash)]
-#[repr(transparent)]
 pub struct RustName {
     pub rust: Ident,
 }
diff --git a/syntax/names.rs b/syntax/names.rs
index ec93c3d..51b1341 100644
--- a/syntax/names.rs
+++ b/syntax/names.rs
@@ -26,10 +26,6 @@ impl RustName {
         RustName { rust }
     }
 
-    pub fn from_ref(rust: &Ident) -> &Self {
-        unsafe { &*(rust as *const Ident as *const Self) }
-    }
-
     pub fn span(&self) -> Span {
         self.rust.span()
     }
diff --git a/syntax/types.rs b/syntax/types.rs
index f7682bc..58a3086 100644
--- a/syntax/types.rs
+++ b/syntax/types.rs
@@ -19,7 +19,7 @@ pub struct Types<'a> {
     pub untrusted: Map<&'a Ident, &'a ExternType>,
     pub required_trivial: Map<&'a Ident, Vec<TrivialReason<'a>>>,
     pub explicit_impls: Set<&'a Impl>,
-    pub resolutions: Map<&'a RustName, &'a Pair>,
+    pub resolutions: Map<&'a Ident, &'a Pair>,
     pub struct_improper_ctypes: UnorderedSet<&'a Ident>,
     pub toposorted_structs: Vec<&'a Struct>,
 }
@@ -63,7 +63,7 @@ impl<'a> Types<'a> {
         }
 
         let mut add_resolution = |pair: &'a Pair| {
-            resolutions.insert(RustName::from_ref(&pair.rust), pair);
+            resolutions.insert(&pair.rust, pair);
         };
 
         let mut type_names = UnorderedSet::new();
@@ -238,7 +238,9 @@ impl<'a> Types<'a> {
     }
 
     pub fn resolve(&self, ident: &RustName) -> &Pair {
-        self.resolutions.get(ident).expect("Unable to resolve type")
+        self.resolutions
+            .get(&ident.rust)
+            .expect("Unable to resolve type")
     }
 }
 

